Public Class Form1

    Dim TT As TrainzTex

    Class TrainzTex

        Public bitmap_old, bitmap_new As Bitmap
        Private filename_open, filename_save, foldername_open, foldername_save As String
        Public tga_has_alpha As Boolean
        Dim r, g, b, a, j, i As Integer

        Property Open_FileName() As String
            Get
                Return filename_open
            End Get
            Set(ByVal value As String)
                filename_open = value
            End Set
        End Property

        Property Save_FileName() As String
            Get
                Return filename_save
            End Get
            Set(ByVal value As String)
                filename_save = value
            End Set
        End Property

        Property Save_FolderName() As String
            Get
                Return foldername_save
            End Get
            Set(ByVal value As String)
                foldername_save = value
            End Set
        End Property

        Property Open_FolderName() As String
            Get
                Return foldername_open
            End Get
            Set(ByVal value As String)
                foldername_open = value
            End Set
        End Property

        Function ChangeColors(ByVal bitmap_old As Bitmap, ByVal has_alpha As Boolean) As Bitmap
            bitmap_new = New Bitmap(bitmap_old.Width, bitmap_old.Height)
            Dim col1, col2 As System.Drawing.Color

            If has_alpha = True Then
                For i = 0 To bitmap_old.Width - 1
                    For j = 0 To bitmap_old.Height - 1
                        col1 = bitmap_old.GetPixel(i, j)
                        r = System.Math.Round(col1.R - ((31 / 255) * col1.R))
                        If r > 255 Then r = 255
                        If r < 0 Then r = 0
                        g = System.Math.Round(col1.G - ((24.8 / 255) * col1.G))
                        If g > 255 Then g = 255
                        If g < 0 Then g = 0
                        b = System.Math.Round(col1.B - ((10.8 / 255) * col1.B))
                        If b > 255 Then b = 255
                        If b < 0 Then b = 0
                        a = col1.A
                        col2 = Color.FromArgb(a, r, g, b)
                        bitmap_new.SetPixel(i, j, col2)
                    Next j
                Next i
            Else
                For i = 0 To bitmap_old.Width - 1
                    For j = 0 To bitmap_old.Height - 1
                        col1 = bitmap_old.GetPixel(i, j)
                        r = System.Math.Round(col1.R - ((31 / 255) * col1.R))
                        If r > 255 Then r = 255
                        If r < 0 Then r = 0
                        g = System.Math.Round(col1.G - ((24.8 / 255) * col1.G))
                        If g > 255 Then g = 255
                        If g < 0 Then g = 0
                        b = System.Math.Round(col1.B - ((10.8 / 255) * col1.B))
                        If b > 255 Then b = 255
                        If b < 0 Then b = 0
                        col2 = Color.FromArgb(r, g, b)
                        bitmap_new.SetPixel(i, j, col2)
                    Next j
                Next i
            End If
            If Form1.Flip_H.Checked = True Then
                bitmap_new.RotateFlip(RotateFlipType.RotateNoneFlipY)
            End If
            If Form1.Flip_V.Checked = True Then
                bitmap_new.RotateFlip(RotateFlipType.RotateNoneFlipX)
            End If
            Return bitmap_new
        End Function

        Sub SaveAsTGA(ByVal bitmap As Bitmap, ByVal save_path As String, ByVal has_alpha As Boolean)
            Dim fs As New IO.FileStream(save_path, IO.FileMode.Create)
            Dim Writer As New IO.BinaryWriter(fs)
            Dim i, j As Integer
            Dim col As Color
            Dim r, g, b, a As Byte

            Dim idlenght As Byte = 0
            Dim colormaptype As Byte = 0
            Dim datatypecode As Byte = 2
            Dim colormaporigin As Short = 0
            Dim colormaplenght As Short = 0
            Dim colormapdepth As Byte = 0
            Dim x_origin As Short = 0
            Dim y_origin As Short = 0
            Dim width As Short = bitmap.Width
            Dim height As Short = bitmap.Height
            Dim bitsperpixel As Byte
            If has_alpha = False Then
                bitsperpixel = 24
            Else
                bitsperpixel = 32
            End If
            Dim imagedescriptor As Byte
            If has_alpha = False Then
                imagedescriptor = 0
            Else
                imagedescriptor = 8
            End If

            Writer.Write(idlenght)
            Writer.Write(colormaptype)
            Writer.Write(datatypecode)
            Writer.Write(colormaporigin)
            Writer.Write(colormaplenght)
            Writer.Write(colormapdepth)
            Writer.Write(x_origin)
            Writer.Write(y_origin)
            Writer.Write(width)
            Writer.Write(height)
            Writer.Write(bitsperpixel)
            Writer.Write(imagedescriptor)


            If has_alpha = False Then
                For i = 0 To bitmap.Height - 1
                    For j = 0 To bitmap.Width - 1
                        col = bitmap.GetPixel(j, i)
                        r = col.R
                        g = col.G
                        b = col.B
                        Writer.Write(b)
                        Writer.Write(g)
                        Writer.Write(r)
                    Next
                Next
            Else
                For i = 0 To bitmap.Height - 1
                    For j = 0 To bitmap.Width - 1
                        col = bitmap.GetPixel(j, i)
                        r = col.R
                        g = col.G
                        b = col.B
                        a = col.A
                        Writer.Write(b)
                        Writer.Write(g)
                        Writer.Write(r)
                        Writer.Write(a)
                    Next
                Next
            End If
            fs.Close()
        End Sub

        Function LoadTGA(ByVal tgafile As String) As Bitmap
            Try
                Dim col1 As System.Drawing.Color
                Dim fs As New IO.FileStream(tgafile, IO.FileMode.Open)
                Dim Reader As New IO.BinaryReader(fs)
                Dim idlenght As Integer
                Dim temp() As Byte
                Dim width As Short
                Dim height As Short
                Dim bitdepth As Byte
                idlenght = Reader.ReadByte()
                temp = Reader.ReadBytes(11)
                width = Reader.ReadInt16()
                height = Reader.ReadInt16()
                bitdepth = Reader.ReadByte
                temp = Reader.ReadBytes(1 + idlenght)

                Dim tga_bitmap As New Bitmap(width, height)

                Try
                    If bitdepth = 24 Then
                        For i = 0 To height - 1
                            For j = 0 To width - 1
                                b = Reader.ReadByte()
                                g = Reader.ReadByte()
                                r = Reader.ReadByte()
                                col1 = Color.FromArgb(r, g, b)
                                tga_bitmap.SetPixel(j, i, col1)
                            Next
                        Next
                    ElseIf bitdepth = 32 Then
                        Me.tga_has_alpha = True
                        For i = 0 To height - 1
                            For j = 0 To width - 1
                                b = Reader.ReadByte()
                                g = Reader.ReadByte()
                                r = Reader.ReadByte()
                                a = Reader.ReadByte()
                                col1 = Color.FromArgb(a, r, g, b)
                                tga_bitmap.SetPixel(j, i, col1)
                            Next
                        Next
                    End If
                Catch
                    MsgBox("Fehler beim Laden! Bitte sicherstellen, dass das zu ladende .tga nicht RLE/Huffman/Deltakomprimiert ist!")
                End Try
                Return tga_bitmap
            Catch
                MsgBox("Fehler beim Laden!")
                Return Nothing
            End Try
        End Function

        Sub SaveAsBMP(ByVal bitmap As Bitmap, ByVal save_path As String)
            bitmap.Save(save_path, Drawing.Imaging.ImageFormat.Bmp)
            bitmap.Dispose()
        End Sub

        Function LoadBMP(ByVal bmpfile As String)
            Try
                Dim bitmap1 As Bitmap
                bitmap1 = Bitmap.FromFile(bmpfile)
                Return bitmap1
            Catch
                MsgBox("Fehler beim Laden!")
                Return Nothing
            End Try
        End Function

        Function LoadJPEG(ByVal jpgfile As String)
            Try
                Dim bitmap1 As Bitmap
                bitmap1 = Bitmap.FromFile(jpgfile)
                Return bitmap1
            Catch
                MsgBox("Fehler beim Laden!")
                Return Nothing
            End Try
        End Function

        Sub BatchConvert(ByVal path As String, ByVal new_path As String, ByVal format As String, ByVal subdirs As Boolean)
            Dim dir As New IO.DirectoryInfo(path)
            Dim file As IO.FileInfo
            If subdirs = False Then
                For Each file In dir.GetFiles()
                    If file.FullName.EndsWith(".tga") And format = "tga" Then
                        SaveAsTGA(ChangeColors(LoadTGA(file.FullName), tga_has_alpha), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.tga", tga_has_alpha)
                    ElseIf file.FullName.EndsWith(".tga") And format = "bmp" Then
                        SaveAsBMP(ChangeColors(LoadTGA(file.FullName), tga_has_alpha), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.bmp")
                    ElseIf file.FullName.EndsWith(".bmp") And format = "bmp" Then
                        SaveAsBMP(ChangeColors(LoadBMP(file.FullName), False), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.bmp")
                    ElseIf file.FullName.EndsWith(".bmp") And format = "tga" Then
                        SaveAsTGA(ChangeColors(LoadBMP(file.FullName), False), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.tga", tga_has_alpha)
                    ElseIf file.FullName.EndsWith(".jpg") And format = "tga" Then
                        SaveAsTGA(ChangeColors(LoadJPEG(file.FullName), False), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.tga", tga_has_alpha)
                    ElseIf file.FullName.EndsWith(".jpg") And format = "bmp" Then
                        SaveAsBMP(ChangeColors(LoadJPEG(file.FullName), False), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.bmp")
                    End If
                Next
            Else
                For Each file In dir.GetFiles()
                    If file.FullName.EndsWith(".tga") And format = "tga" Then
                        SaveAsTGA(ChangeColors(LoadTGA(file.FullName), tga_has_alpha), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.tga", tga_has_alpha)
                    ElseIf file.FullName.EndsWith(".tga") And format = "bmp" Then
                        SaveAsBMP(ChangeColors(LoadTGA(file.FullName), tga_has_alpha), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.bmp")
                    ElseIf file.FullName.EndsWith(".bmp") And format = "bmp" Then
                        SaveAsBMP(ChangeColors(LoadBMP(file.FullName), False), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.bmp")
                    ElseIf file.FullName.EndsWith(".bmp") And format = "tga" Then
                        SaveAsTGA(ChangeColors(LoadBMP(file.FullName), False), new_path + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.tga", tga_has_alpha)
                    End If
                Next
                Dim subdir As IO.DirectoryInfo
                For Each subdir In dir.GetDirectories
                    For Each file In subdir.GetFiles()
                        If file.FullName.EndsWith(".tga") And format = "tga" Then
                            SaveAsTGA(ChangeColors(LoadTGA(file.FullName), tga_has_alpha), new_path + "\" + subdir.Name + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.tga", tga_has_alpha)
                        ElseIf file.FullName.EndsWith(".tga") And format = "bmp" Then
                            SaveAsBMP(ChangeColors(LoadTGA(file.FullName), tga_has_alpha), new_path + "\" + subdir.Name + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.bmp")
                        ElseIf file.FullName.EndsWith(".bmp") And format = "bmp" Then
                            SaveAsBMP(ChangeColors(LoadBMP(file.FullName), False), new_path + "\" + subdir.Name + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.bmp")
                        ElseIf file.FullName.EndsWith(".bmp") And format = "tga" Then
                            SaveAsTGA(ChangeColors(LoadBMP(file.FullName), False), new_path + "\" + subdir.Name + "\" + IO.Path.GetFileNameWithoutExtension(file.FullName) + "_TT.tga", tga_has_alpha)
                        End If
                    Next
                Next
            End If
        End Sub

        Function MergeBMPs(ByVal bitmap1 As Bitmap, ByVal Bitmap2 As Bitmap) As Bitmap
            Dim col1, col2, col3 As Color
            Dim bitmap As New Bitmap(bitmap1.Width, bitmap1.Height, Drawing.Imaging.PixelFormat.Format32bppArgb)

            For i = 0 To bitmap1.Width - 1
                For j = 0 To bitmap1.Height - 1
                    col1 = bitmap1.GetPixel(i, j)
                    col2 = Bitmap2.GetPixel(i, j)
                    col3 = Color.FromArgb(col2.R, col1.R, col1.G, col1.B)
                    bitmap.SetPixel(i, j, col3)
                Next
            Next

            Return bitmap
        End Function

    End Class

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        TT = New TrainzTex()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Open.ShowDialog()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If TT.Open_FileName = "" Then
            MsgBox("Bitte zuerst Schritt 1 ausfhren!")
            Exit Sub
        End If
        Save.ShowDialog()
    End Sub

    Private Sub Save_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Save.FileOk
        TT.Save_FileName = Save.FileName
        Label_PfadNeu.Text = "Neuer Pfad: " + Save.FileName()
        Save.Dispose()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Try
            If TT.Save_FileName.EndsWith(".bmp") Then
                TT.SaveAsBMP(TT.ChangeColors(TT.bitmap_old, False), TT.Save_FileName)
            ElseIf TT.Save_FileName.EndsWith(".tga") Then
                TT.SaveAsTGA(TT.ChangeColors(TT.bitmap_old, TT.tga_has_alpha), TT.Save_FileName, TT.tga_has_alpha)
            Else
                MsgBox("Bitte nur bmp- oder tga-Format whlen!")
            End If
        Catch
            MsgBox("Bitte berprfen ob die zu ladende Datei existiert/eine gltige Bilddatei ist und eine zu speichernde Datei  eingegeben ist!", MsgBoxStyle.Critical, "Bitte Eingaben berprfen!")
        End Try
    End Sub

    Private Sub Open_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Open.FileOk
        If Open.FileName.EndsWith(".bmp") Or Open.FileName.EndsWith(".tga") Or Open.FileName.EndsWith(".jpg") Then
            TT.Open_FileName = Open.FileName
            Label_Pfad.Text = "Alter Pfad: " + Open.FileName()
            If Open.FileName.EndsWith(".bmp") Then
                TT.bitmap_old = TT.LoadBMP(TT.Open_FileName)
            End If
            If Open.FileName.EndsWith(".tga") Then
                TT.bitmap_old = TT.LoadTGA(TT.Open_FileName)
            End If
            If Open.FileName.EndsWith(".jpg") Then
                TT.bitmap_old = TT.LoadJPEG(TT.Open_FileName)
            End If
            Open.Dispose()
        Else
            MsgBox("Bitte berprfen, ob eine .tga oder eine .bmp-Datei angegeben wurde!")
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        If Open_folder.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Label_Ordner.Text = "Ordner: " + Open_folder.SelectedPath
            TT.Open_FolderName = Open_folder.SelectedPath
            Open_folder.Dispose()
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        If Save_folder.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Label_OrdnerNeu.Text = "Neuer Ordner: " + Save_folder.SelectedPath
            TT.Save_FolderName = Save_folder.SelectedPath
            Save_folder.Dispose()
        End If
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        If TT.Open_FolderName = "" Or TT.Save_FolderName = "" Then
            MsgBox("Bitte sicherstellen, dass beide Angaben gemacht wurden und die Ordner berhaupt existieren!")
        End If
        If TGA.Checked = False And BMP.Checked = False Then
            MsgBox("Bitte ein Format auswhlen!")
        End If
        If TGA.Checked = True Then
            TT.BatchConvert(TT.Open_FolderName, TT.Save_FolderName, "tga", Subdirs.Checked)
        ElseIf BMP.Checked = True Then
            TT.BatchConvert(TT.Open_FolderName, TT.Save_FolderName, "bmp", Subdirs.Checked)
        End If
    End Sub

    Private Sub TGA_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TGA.CheckedChanged
        If TGA.Checked = True Then BMP.Checked = False
    End Sub

    Private Sub BMP_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BMP.CheckedChanged
        If BMP.Checked = True Then TGA.Checked = False
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Form2.Show()
    End Sub
End Class
